linear-1.20.3: Linear Algebra

License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | portable
Safe Haskell | None
Language | Haskell98

Linear.Algebra

Description

Synopsis

- class Num r => Algebra r m where
  - mult :: (m -> m -> r) -> m -> r
  - unital :: r -> m -> r
- class Num r => Coalgebra r m where
  - comult :: (m -> r) -> m -> m -> r
  - counital :: (m -> r) -> r
- multRep :: (Representable f, Algebra r (Rep f)) => f (f r) -> f r
- unitalRep :: (Representable f, Algebra r (Rep f)) => r -> f r
- comultRep :: (Representable f, Coalgebra r (Rep f)) => f r -> f (f r)
- counitalRep :: (Representable f, Coalgebra r (Rep f)) => f r -> r

# Documentation

class Num r => Algebra r m where Source

An associative unital algebra over a ring

Methods

mult :: (m -> m -> r) -> m -> r Source

unital :: r -> m -> r Source

Instances

Num r => Algebra r () Source |
Num r => Algebra r Void Source |
(Num r, TrivialConjugate r) => Algebra r (E Quaternion) Source |
Num r => Algebra r (E Complex) Source |
Num r => Algebra r (E V1) Source |
Num r => Algebra r (E V0) Source |
(Algebra r a, Algebra r b) => Algebra r (a, b) Source |

class Num r => Coalgebra r m where Source

A coassociative counital coalgebra over a ring

Methods

comult :: (m -> r) -> m -> m -> r Source

counital :: (m -> r) -> r Source

Instances

Num r => Coalgebra r () Source |
Num r => Coalgebra r Void Source |
(Num r, TrivialConjugate r) => Coalgebra r (E Quaternion) Source |
Num r => Coalgebra r (E Complex) Source |
Num r => Coalgebra r (E V4) Source |
Num r => Coalgebra r (E V3) Source |
Num r => Coalgebra r (E V2) Source |
Num r => Coalgebra r (E V1) Source |
Num r => Coalgebra r (E V0) Source |
(Coalgebra r m, Coalgebra r n) => Coalgebra r (m, n) Source |

multRep :: (Representable f, Algebra r (Rep f)) => f (f r) -> f r Source

unitalRep :: (Representable f, Algebra r (Rep f)) => r -> f r Source

comultRep :: (Representable f, Coalgebra r (Rep f)) => f r -> f (f r) Source

counitalRep :: (Representable f, Coalgebra r (Rep f)) => f r -> r Source